searchData={"content_type":"text/markdown","items":[{"doc":"This module provides primitives to build XML document as a `Stream`","ref":"XmlStream.html","title":"XmlStream","type":"module"},{"doc":"import XmlStream\n\n    rows = Stream.map(1..1000, fn i ->\n      cells = Stream.map(1..40, fn j ->\n        element(\"cell\", %{row: to_string(i), column: to_string(j)}, content(to_string(i)))\n      end)\n      element(\"row\", cells)\n    end)\n\n    stream!([declaration(), element(\"sheet\", rows)], printer: XmlStream.Printer.Ugly)\n    |> Stream.into(File.stream!(\"sheet.xml\"))\n    |> Stream.run\n\n\nThe body of an element could be either a eager `Enumerable` or a\nlazy one built via `Stream` module. The primitive functions like\n`element/3`, `content/1` are used to build a tree structure where\nsome nodes are not fully evaluated (child nodes could a\nstream). `stream!/2` does a depth first traversal of the tree and\nruns the stream as necessary when it encounters one and returns a\nnew stream of element type `iodata`","ref":"XmlStream.html#module-example","title":"Example - XmlStream","type":"module"},{"doc":"","ref":"XmlStream.html#cdata/1","title":"XmlStream.cdata/1","type":"function"},{"doc":"","ref":"XmlStream.html#comment/1","title":"XmlStream.comment/1","type":"function"},{"doc":"","ref":"XmlStream.html#content/1","title":"XmlStream.content/1","type":"function"},{"doc":"","ref":"XmlStream.html#declaration/1","title":"XmlStream.declaration/1","type":"function"},{"doc":"","ref":"XmlStream.html#doctype/2","title":"XmlStream.doctype/2","type":"function"},{"doc":"","ref":"XmlStream.html#element/2","title":"XmlStream.element/2","type":"function"},{"doc":"","ref":"XmlStream.html#element/3","title":"XmlStream.element/3","type":"function"},{"doc":"","ref":"XmlStream.html#empty_element/2","title":"XmlStream.empty_element/2","type":"function"},{"doc":"","ref":"XmlStream.html#processing_instruction/2","title":"XmlStream.processing_instruction/2","type":"function"},{"doc":"Creates a xml document stream.","ref":"XmlStream.html#stream!/2","title":"XmlStream.stream!/2","type":"function"},{"doc":"* `:printer` (module) - The printer that should be used for formatting\nAvailable options are `XmlStream.Printer.Pretty` and `XmlStream.Printer.Ugly`\n\n* `:indent_with` (string) - The string that should be used for indentation. Defaults to `\"\\t\"`.","ref":"XmlStream.html#stream!/2-options","title":"Options - XmlStream.stream!/2","type":"function"},{"doc":"Could be either `Keyword` or `map`. Order of the attributes are\npreserved in case of `Keyword`","ref":"XmlStream.html#t:attrs/0","title":"XmlStream.attrs/0","type":"type"},{"doc":"The elements of `Enumerable` should be of type `t:fragment/0`","ref":"XmlStream.html#t:body/0","title":"XmlStream.body/0","type":"type"},{"doc":"","ref":"XmlStream.html#t:fragment/0","title":"XmlStream.fragment/0","type":"type"},{"doc":"","ref":"XmlStream.Printer.html","title":"XmlStream.Printer","type":"behaviour"},{"doc":"","ref":"XmlStream.Printer.html#c:init/1","title":"XmlStream.Printer.init/1","type":"callback"},{"doc":"","ref":"XmlStream.Printer.html#c:print/2","title":"XmlStream.Printer.print/2","type":"callback"},{"doc":"","ref":"XmlStream.Printer.Pretty.html","title":"XmlStream.Printer.Pretty","type":"module"},{"doc":"","ref":"XmlStream.Printer.Pretty.html#init/1","title":"XmlStream.Printer.Pretty.init/1","type":"function"},{"doc":"","ref":"XmlStream.Printer.Pretty.html#print/2","title":"XmlStream.Printer.Pretty.print/2","type":"function"},{"doc":"","ref":"XmlStream.Printer.Ugly.html","title":"XmlStream.Printer.Ugly","type":"module"},{"doc":"","ref":"XmlStream.Printer.Ugly.html#init/1","title":"XmlStream.Printer.Ugly.init/1","type":"function"},{"doc":"","ref":"XmlStream.Printer.Ugly.html#print/2","title":"XmlStream.Printer.Ugly.print/2","type":"function"},{"doc":"","ref":"XmlStream.EncodeError.html","title":"XmlStream.EncodeError","type":"exception"},{"doc":"","ref":"XmlStream.EncodeError.html#t:t/0","title":"XmlStream.EncodeError.t/0","type":"type"},{"doc":"# XmlStream\n\n[![Hex.pm](https://img.shields.io/hexpm/v/xml_stream.svg)](https://hex.pm/packages/xml_stream)\n\nAn Elixir library for building XML document in a streaming fashion.\n\n\n#","ref":"readme.html","title":"XmlStream","type":"extras"},{"doc":"There are cases where constructing the whole XML document in memory is\na not viable option. Exporting records as a xlsx document is a good\nexample. This library provides primitives to build XML document\nas a [stream](https://hexdocs.pm/elixir/Stream.html). Please see\n[documentation](https://hexdocs.pm/xml_stream) for more information.","ref":"readme.html#use-cases","title":"Use cases - XmlStream","type":"extras"}]}